var apiUrl = "https://api.ynzs.cn/Public/v2/"; //API入口地址
var mainUrl = "http://wap.ynzs.cn"; //资源请求地址
var pageSize = 10; //分页条数
var myAngle = 10; //自定义返回滑动角度
var myDevice = {}; //定义我的硬件信息

/**
 * 页面加载提示
 * @param {notice} 提示信息
 */
function loadOpen(notice) {
	plus.nativeUI.showWaiting(notice, {
		width: "60%",
		height: "30%",
		round: 15,
		textalign: "center",
		padding: "5%",
		background: "rgba(2,2,2,0.5)",
		color: "rgba(255,255,255,1)",
		modal: false,
		padlock: true,
		loading: {
			display: "inline",
			height: "30%",
			icon: "/images/loading.png",
			interval: 200
		}
	});
}

/**
 * 关闭页面加载提示
 */
function loadClose() {
	plus.nativeUI.closeWaiting();
}

/**
 * 根据传入的URL和窗口ID打开，带提示
 * @param {url} URL地址
 * @param {id} webid
 * @param {notice} 提示信息
 */
function openWin(url, id, notice) {
	console.log("访问页面:" + url);
	console.log("登陆状态数据:" + JSON.stringify(plus.storage.getItem("isLogin")));
	console.log("用户数据:" + JSON.stringify(plus.storage.getItem("userinfo")));
	console.log("用户类型数据:" + JSON.stringify(plus.storage.getItem("isWeike")));
	loadOpen(notice);
	//	mui.openWindow({
	//		url: url,
	//		id: id,
	//		waiting: {
	//			autoShow: false
	//		},
	//		show:{
	//			aniShow:"fade-in"
	//		}
	//	});
	plus.webview.open(url, id, null, "pop-in");
}

/**
 * 根据传入的URL和窗口ID打开，不带提示
 * @param {url} URL地址
 * @param {id} webid
 */
function openWin2(url, id) {
	console.log("访问页面:" + url);
	console.log("登陆状态数据:" + JSON.stringify(plus.storage.getItem("isLogin")));
	console.log("用户数据:" + JSON.stringify(plus.storage.getItem("userinfo")));
	console.log("用户类型数据:" + JSON.stringify(plus.storage.getItem("isWeike")));
	//	mui.openWindow({
	//		url: url,
	//		id: id,
	//		waiting: {
	//			autoShow: false
	//		},
	//		show:{
	//			aniShow:"fade-in"
	//		}
	//	});
	plus.webview.open(url, id, null, "pop-in");
}

/**
 * 访问详情页方法
 * @param {url} URL地址
 * @param {id} webid
 * @param {did} 传参数，ID
 */
function openDWin(url, id, did) {
	console.log("访问页面:" + url);
	console.log("登陆状态数据:" + JSON.stringify(plus.storage.getItem("isLogin")));
	console.log("用户数据:" + JSON.stringify(plus.storage.getItem("userinfo")));
	console.log("用户类型数据:" + JSON.stringify(plus.storage.getItem("isWeike")));
	loadOpen("正在加载");
	mui.openWindow({
		url: url,
		id: id,
		waiting: {
			autoShow: false
		},
		extras: {
			nid: did
		},
		show: {
			aniShow: "pop-in"
		}
	});
}

/**
 * 访问广告页
 * @param {url} URL地址
 * @param {id} webid
 * @param {durl} 传参数访问的url
 */
function openAD(url, id, durl) {
	console.log("访问页面:" + url);
	mui.openWindow({
		url: url,
		id: id,
		waiting: {
			autoShow: false
		},
		extras: {
			durl: durl
		},
		show: {
			aniShow: "pop-in"
		}
	});
}

/**
 * 访问新闻详情页方法
 * @param {url} URL地址
 * @param {id} webid
 * @param {channel} 传参数，栏目
 * @param {tid} 传参数，ID
 */
function openNewsWin(url, id, channel, tid) {
	console.log("访问页面:" + url);
	console.log("登陆状态数据:" + JSON.stringify(plus.storage.getItem("isLogin")));
	console.log("用户数据:" + JSON.stringify(plus.storage.getItem("userinfo")));
	console.log("用户类型数据:" + JSON.stringify(plus.storage.getItem("isWeike")));
	loadOpen("正在加载");
	mui.openWindow({
		url: url,
		id: id,
		waiting: {
			autoShow: false
		},
		extras: {
			channel: channel,
			tid: tid
		},
		show: {
			aniShow: "pop-in"
		}
	});
}

/**
 * 访问消息详情方法
 * @param {url} URL地址
 * @param {id} webid
 * @param {did} 传参数，对象UID
 */
function openMsgWin(url, id, did) {
	console.log("访问页面:" + url);
	console.log("登陆状态数据:" + JSON.stringify(plus.storage.getItem("isLogin")));
	console.log("用户数据:" + JSON.stringify(plus.storage.getItem("userinfo")));
	console.log("用户类型数据:" + JSON.stringify(plus.storage.getItem("isWeike")));
	loadOpen("正在加载");
	mui.openWindow({
		url: url,
		id: id,
		waiting: {
			autoShow: false
		},
		extras: {
			did: did
		},
		show: {
			aniShow: "pop-in"
		}
	});
}

/**
 * 带编辑参数访问详情方法
 * @param {url} URL地址
 * @param {id} webid
 * @param {did} 传参数，ID
 * @param {edit} 传参数0/1，0为不编辑，1为编辑
 */
function openEWin(url, id, did, eidt) {
	console.log("访问页面:" + url);
	console.log("登陆状态数据:" + JSON.stringify(plus.storage.getItem("isLogin")));
	console.log("用户数据:" + JSON.stringify(plus.storage.getItem("userinfo")));
	console.log("用户类型数据:" + JSON.stringify(plus.storage.getItem("isWeike")));
	loadOpen("正在加载");
	mui.openWindow({
		url: url,
		id: id,
		waiting: {
			autoShow: false
		},
		extras: {
			nid: did,
			edit: eidt
		},
		show: {
			aniShow: "pop-in"
		}
	});
}

/**
 * 根据传入的URL和窗口ID创建子页面
 * @param {url} URL地址
 * @param {id} webid
 */
function openSub(url, id) {
	loadOpen("正在加载");
	var self = plus.webview.currentWebview();
	//添加子页面
	var child = plus.webview.create(url, id, {
		top: (mui.os.ios ? "80px" : "80px"),
		bottom: "0px"
	});
	self.append(child);
};

/**
 * 根据传入的URL和窗口ID创建新闻子页面
 * @param {url} URL地址
 * @param {id} webid
 */
function openNewsSub(url, id) {
	loadOpen("正在加载");
	var self = plus.webview.currentWebview();
	//添加子页面
	var child = plus.webview.create(url, id, {
		top: (mui.os.ios ? "45px" : "45px"),
		bottom: "0px"
	});
	self.append(child);
};

var errorTimeout = true;
var errorParser = true;
var errorAbort = true;
var errorOther = true;

/**
 * JSON请求错误提示，不可单独使用
 * @param {XMLHttpRequest} 请求参数
 * @param {textStatus} 响应数据
 * @param {errorThrown} 错误信息
 */
function errorHandler(XMLHttpRequest, textStatus, errorThrown) {
	console.log(XMLHttpRequest + "    " + textStatus + "    " + errorThrown);
	console.log(JSON.stringify(XMLHttpRequest));
	if(textStatus == "timeout" && errorTimeout) {
		errorTimeout = false;
		mui.toast("网络不给力哦！请稍后再试")
	} else {
		if((textStatus == "error" || textStatus == "parsererror") && errorParser) {
			errorParser = false;
			mui.toast("系统错误！请稍后再试。")
		} else {
			if(textStatus == "abort" && errorAbort) {
				errorAbort = false;
				mui.toast("网络不可用哦! 请检查你的网络")
			} else {
				if(errorOther) {
					errorOther = false;
					mui.toast("系统繁忙！请稍后再试")
				}
			}
		}
	}
}

/**
 * JSON请求。POST方式
 * @parm {parts} 请求地址
 * @param {datas} 请求参数
 * @param {func} 回调
 * @returns {func(data.result)}
 */
function postAjax(parts, datas, func) {

	mui.ajax({
		url: apiUrl + parts,
		type: "post",
		data: datas,
		dataType: 'json',
		timeout: 10000,
		success: function(data) {
			console.log("请求参数：" + apiUrl + parts + ";请求数据：" + JSON.stringify(datas));
			console.log("返回数据：" + JSON.stringify(data));
			if(data.data.status == "true") {
				func(data.data.data);
			} else {
				loadClose();
				mui.toast(data.data.info);
			}
		},
		error: function(xhr, type, errorThrown) {
			console.log("请求参数：" + apiUrl + parts + ";请求数据：" + JSON.stringify(datas));
			loadClose();
			errorHandler(xhr, type, errorThrown)
		}
	});
}

/**
 * JSON请求。POST方式,返回带sign
 * @parm {parts} 请求地址
 * @param {datas} 请求参数
 * @param {func} 回调
 * @returns {func(data.data)}
 */
function postAjaxSign(parts, datas, func) {
	console.log("请求参数：" + apiUrl + parts + ";请求数据：" + JSON.stringify(datas));
	mui.ajax({
		url: apiUrl + parts,
		type: "post",
		data: datas,
		dataType: 'json',
		timeout: 10000,
		success: function(data) {
			console.log(JSON.stringify(data));
			if(data.data.status == "true") {
				func(data.data);
			} else {
				loadClose();
				console.log(apiUrl + parts + "请求数据失败！");
				mui.toast(data.data.info);
			}
		},
		error: function(xhr, type, errorThrown) {
			loadClose();
			errorHandler(xhr, type, errorThrown)
		}
	});
}

/**
 * JSON请求。POST方式
 * @parm {parts} 请求地址
 * @param {datas} 请求参数
 * @param {func} 回调
 * @returns {func(data)}
 */
function postAllAjax(parts, datas, func) {
	console.log("请求参数：" + apiUrl + parts + ";请求数据：" + JSON.stringify(datas));
	mui.ajax({
		url: apiUrl + parts,
		type: "post",
		data: datas,
		dataType: 'json',
		timeout: 10000,
		success: function(data) {
			console.log(JSON.stringify(data));
			if(data.status == true) {
				mui.toast(data.info);
				func(data);
			} else {
				loadClose();
				console.log(apiUrl + parts + "请求数据失败！");
				mui.toast(data.info);
			}
		},
		error: function(xhr, type, errorThrown) {
			loadClose();
			errorHandler(xhr, type, errorThrown)
		}
	});
}

//JSON请求。GET方式，无参数
/**
 * JSON请求。GET方式，无参数
 * @param {func} 回调
 * @returns {func(data.result.result)}
 */
function getAjax(func) {
	mui.ajax({
		url: apiUrl,
		type: "get",
		dataType: "json",
		timeout: 10000,
		success: function(data) {
			func(data)
		},
		error: function(xhr, type, errorThrown) {
			loadClose();
			if(url.indexOf("GetUserLoginSta") >= 0 || url.indexOf("GetNewMsgTotal") >= 0) {} else {
				errorHandler(xhr, type, errorThrown, url)
			}
		}
	})
}

/**
 *TEXT请求。GET方式，无参数
 * @param {func} 回调
 * @returns {func(data.result.result)}
 */
function getAjax2(func) {
	mui.ajax({
		url: apiUrl,
		type: "get",
		dataType: "text",
		timeout: 10000,
		success: function(data) {
			func(data)
		},
		error: function(xhr, type, errorThrown) {
			loadClose();
			errorHandler(xhr, type, errorThrown)
		}
	})
}

/**
 * 拨打业务电话
 * @param {number} 电话号码
 */
function call(number) {
	mui.confirm("是否拨打业务电话？", "联系客服", ["立即拨打", "取消"], function(e) {
		if(e.index == 0) {
			plus.device.dial(number, true);
		}
	});
}

/**
 * 拨打招生电话
 * @param {number} 电话号码
 */
function schoolcall(number) {
	mui.confirm("是否拨打招生电话？", "联系学校", ["立即拨打", "取消"], function(e) {
		if(e.index == 0) {
			plus.device.dial(number, true);
		}
	});
}

/**
 * 上传文件
 * @param {upfile} 本地文件路径
 * @returns {imgUploadUrl} 返回服务器路径
 */
function uploadImage(upfile) {
	if(upfile.length <= 0) {
		mui.toast("没有添加上传文件！");
		return;
	}
	var tempfile = "_doc/upfile.jpg";
	//图片压缩
	plus.io.resolveLocalFileSystemURL(upfile, function(entry) {
		var imgFileName = entry.name;
		entry.file(function(file) {
			file.close();
			loadOpen("正在压缩并上传图片");
			//上传前压缩图片
			plus.zip.compressImage({
				src: upfile,
				dst: tempfile,
				quality: 60,
				overwrite: true,
				width: "2000px"
			}, function() {
				mui.toast("压缩图片成功");
				//图片上传
				var task = plus.uploader.createUpload(imgPostUrl, {
					method: "POST"
				}, function(t, status) { //上传完成
					if(status == 200) {
						mui.toast("上传成功！");
						console.log(t.responseText);
						imgUploadUrl = imgFileName + "#" + t.responseText;
						loadClose();
					} else {
						mui.toast("上传失败！" + status);
						console.log("上传失败！" + status);
						loadClose();
					}
				});
				task.addFile(tempfile, {
					key: upfile
				});
				task.start();
			});

		})
	});
}

/**
 * 上传企业Logo
 * @param {upfile} 本地文件路径
 * @returns {imgUploadUrl} 返回服务器路径
 */
function uploadLogo(upfile) {
	if(upfile.length <= 0) {
		mui.toast("没有添加上传文件！");
		return;
	}
	var tempfile = "_doc/upfile.jpg";
	//图片压缩
	plus.io.resolveLocalFileSystemURL(upfile, function(entry) {
		var imgFileName = entry.name;
		entry.file(function(file) {
			file.close();
			loadOpen("正在压缩并上传图片");
			//上传前压缩图片
			plus.zip.compressImage({
				src: upfile,
				dst: tempfile,
				quality: 60,
				overwrite: true,
				width: "2000px"
			}, function() {
				mui.toast("压缩图片成功");
				//图片上传
				var task = plus.uploader.createUpload(imgPostUrl, {
					method: "POST"
				}, function(t, status) { //上传完成
					if(status == 200) {
						mui.toast("上传成功！");
						console.log(t.responseText);
						logoUploadUrl = t.responseText;
						loadClose();
					} else {
						mui.toast("上传失败！" + status);
						console.log("上传失败！" + status);
						loadClose();
					}
				});
				task.addFile(tempfile, {
					key: upfile
				});
				task.start();
			});

		})
	});
}

/**
 * 上传用户头像
 * @param {upfile} 本地文件路径
 * @returns {imgUploadUrl} 返回服务器路径
 */
function uploadUserImage(upfile) {
	if(upfile.length <= 0) {
		mui.toast("没有添加上传文件！");
		return;
	}
	var tempfile1 = "_doc/upfile1.jpg";
	var tempfile2 = "_doc/upfile2.jpg";
	var tempfile3 = "_doc/upfile3.jpg";
	//图片压缩
	plus.io.resolveLocalFileSystemURL(uid, upfile, function(entry) {
		entry.file(function(file) {
			file.close();
			loadOpen("正在上传图片");
			//上传前压缩图片
			plus.zip.compressImage({
				src: upfile,
				dst: tempfile1,
				quality: 60,
				overwrite: true,
				width: "150px",
				height: "150px"
			}, function() {
				console.log(tempfile1 + "压缩图片成功");

			});
			plus.zip.compressImage({
				src: upfile,
				dst: tempfile2,
				quality: 60,
				overwrite: true,
				width: "100px",
				height: "100px"
			}, function() {
				console.log(tempfile2 + "压缩图片成功");

			});
			plus.zip.compressImage({
				src: upfile,
				dst: tempfile3,
				quality: 60,
				overwrite: true,
				width: "50px",
				height: "50px"
			}, function() {
				console.log(tempfile3 + "压缩图片成功");

			});
			//图片上传
			var task = plus.uploader.createUpload(apiUrl + "?do=appapi&fn=updateMyAavatar", {
				method: "POST"
			}, function(t, status) { //上传完成
				if(status == 200) {
					mui.toast("上传成功！");
					console.log(t.responseText);
					imgUploadUrl = imgFileName + "#" + t.responseText;
					loadClose();
				} else {
					mui.toast("上传失败！" + status);
					console.log("上传失败！" + status);
					loadClose();
				}
			});
			task.addFile(tempfile1, {
				key: upfile
			});
			task.addFile(tempfile2, {
				key: upfile
			});
			task.addFile(tempfile3, {
				key: upfile
			});
			task.start();
		})
	});
}

/**
 * 下载文件
 * @param {url} 远程URL地址
 */
function openDown(url) {
	mui.toast("准备下载文件");
	console.log("准备下载文件:" + url);
	plus.downloader.createDownload(url, {}, function(d, status) {
		console.log(d.filename);
		if(status == 200) {
			mui.toast("下载成功，文件：" + d.filename);

			mui.confirm("是否打开该文件？", "打开文件", ["打开", "取消"], function(e) {
				if(e.index == 0) {
					plus.runtime.openFile(d.filename);
				}
			});
		} else {
			mui.toast("下载失败，失败原因：" + status);
		}
	}).start();
}

/**
 * 获取文本长度
 * @param {str} 文本
 * @returns {realLength} 长度
 */
function GetLength(str) {
	var realLength = 0,
		len = str.length,
		charCode = -1;
	for(var i = 0; i < len; i++) {
		charCode = str.charCodeAt(i);
		if(charCode >= 0 && charCode <= 128) realLength += 1;
		else realLength += 2;
	}
	return realLength;
};

/**
 * 截取字符串,如果给定的字符串大于指定长度，截取指定长度返回，否者返回源字符串。 
 * @param {str} 文本
 * @param {len} 目标长度
 * @returns {Object} 截取后的文本
 */
function cutstr(str, len) {
	var str_length = 0;
	var str_len = 0;
	str_cut = new String();
	str_len = str.length;
	for(var i = 0; i < str_len; i++) {
		a = str.charAt(i);
		str_length++;
		if(escape(a).length > 4) {
			//中文字符的长度经编码之后大于4  
			str_length++;
		}
		str_cut = str_cut.concat(a);
		if(str_length >= len) {
			str_cut = str_cut.concat("...");
			return str_cut;
		}
	}
	//如果给定字符串小于指定长度，则返回源字符串；  
	if(str_length < len) {
		return str;
	}
}

/**
 * 按钮倒计时
 * @param {t} 倒计时时间，单位s
 * @param {obj} 对象，必须是input或者button
 * @param {waitMessage} 倒计时后面显示的时间
 */
function disableWait(t, obj, waitMessage) {
	var objTag = obj.tagName.toLowerCase();
	if(objTag !== "input" && objTag != "button") {
		return;
	}

	var v = objTag !== "input" ? obj.innerText : obj.value;
	var i = setInterval(function() {
		if(t > 0) {
			switch(objTag) {
				case "input":
					obj.value = (--t) + waitMessage;
					break;
				case "button":
					obj.innerText = (--t) + waitMessage;
					break;
				default:
					break;
			}
			obj.disabled = true;
		} else {
			window.clearInterval(i);
			switch(objTag) {
				case "input":
					obj.value = v;
					break;
				case "button":
					obj.innerText = v;
					break;
				default:
					break;
			}
			obj.disabled = false;
		}
	}, 1000);
}

/**
 * 清除子元素 
 * @param {dg} dom元素
 */
function clearDom(dg) {
	var child = dg.childNodes;
	for(var i = child.length - 1; i >= 0; i--) {
		dg.removeChild(child.item(i));
	}
}

/**
 * 时间戳转换时间 
 * @param {datatime} 需要转换的时间戳
 * @returns {newDate} 转换后的时间
 */
function convertDate(datetime) {
	var newDate = new Date();
	newDate.setTime(datetime * 1000);
	return newDate.getFullYear() + '-' + (newDate.getMonth() + 1 < 10 ? '0' + (newDate.getMonth() + 1) : newDate.getMonth() + 1) + '-' + newDate.getDate() + ' ' + newDate.getHours() + ':' + newDate.getMinutes() + ':' + newDate.getSeconds();
}

/**
 * 时间转换时间戳 
 * @param {datatime} 需要转换的时间
 * @returns {timestamp} 转换后的时间戳
 */
function convertTimestamp(datetime) {
	var timestamp = Date.parse(new Date(datetime));
	timestamp = timestamp / 1000;
	return timestamp;
}

/**
 * 比较2个日期的间隔天数 
 * @param {DateOne} 开始日期
 * @param {DateTwo} 结束日期
 * @returns {cha} 间隔天数
 */
function getDays(DateOne, DateTwo) {
	var OneMonth = DateOne.substring(5, DateOne.lastIndexOf('-'));
	var OneDay = DateOne.substring(DateOne.length, DateOne.lastIndexOf('-') + 1);
	var OneYear = DateOne.substring(0, DateOne.indexOf('-'));

	var TwoMonth = DateTwo.substring(5, DateTwo.lastIndexOf('-'));
	var TwoDay = DateTwo.substring(DateTwo.length, DateTwo.lastIndexOf('-') + 1);
	var TwoYear = DateTwo.substring(0, DateTwo.indexOf('-'));

	var cha = ((Date.parse(OneMonth + '/' + OneDay + '/' + OneYear) - Date.parse(TwoMonth + '/' + TwoDay + '/' + TwoYear)) / 86400000);
	return Math.abs(cha);
}

// 对Date的扩展，将 Date 转化为指定格式的String
// 月(M)、日(d)、小时(h)、分(m)、秒(s)、季度(q) 可以用 1-2 个占位符， 
// 年(y)可以用 1-4 个占位符，毫秒(S)只能用 1 个占位符(是 1-3 位的数字) 
// 例子： 
// (new Date()).Format("yyyy-MM-dd hh:mm:ss.S") ==> 2006-07-02 08:09:04.423 
// (new Date()).Format("yyyy-M-d h:m:s.S")      ==> 2006-7-2 8:9:4.18 
Date.prototype.Format = function(fmt) { //author: meizz 
	var o = {
		"M+": this.getMonth() + 1, //月份 
		"d+": this.getDate(), //日 
		"h+": this.getHours(), //小时 
		"m+": this.getMinutes(), //分 
		"s+": this.getSeconds(), //秒 
		"q+": Math.floor((this.getMonth() + 3) / 3), //季度 
		"S": this.getMilliseconds() //毫秒 
	};
	if(/(y+)/.test(fmt)) fmt = fmt.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
	for(var k in o)
		if(new RegExp("(" + k + ")").test(fmt)) fmt = fmt.replace(RegExp.$1, (RegExp.$1.length == 1) ? (o[k]) : (("00" + o[k]).substr(("" + o[k]).length)));
	return fmt;
}

/**
 * 生成随机数，用于图片更新 
 * @returns {Math} 随机数
 */
function GetRandomNum() {
	var Num = "";
	for(var i = 0; i < 6; i++) {
		Num += Math.floor(Math.random() * 10);
	}
	return Num;
}

/**
 * 时间戳转换时间-任务发布时间
 * @param {datatime} 需要转换的时间戳
 * @returns {newDate} 转换后的时间，格式化为yyyy-MM-dd
 */
function convertSubDate(datetime) {
	var newDate = new Date();
	newDate.setTime(datetime * 1000);
	return newDate.getFullYear() + '-' + (newDate.getMonth() + 1 < 10 ? '0' + (newDate.getMonth() + 1) : newDate.getMonth() + 1) + '-' + newDate.getDate();
}

/**
 * 将json中的html解析输出
 * @param {str} 需要转换的时json string
 * @returns {str} 转换后html
 */
function ChangeStringToHTML(str) {
	str = str.Replace("<", "&lt;");
	str = str.Replace(">", "&gt;");
	str = str.Replace(" ", "&nbsp;");
	str = str.Replace("\n", "<br>");
	str = str.Replace("&", "&amp;");
	return str;
}