var updataUrl = "https://update.sykjwh.cn/api/v1/index.aspx"; //APP升级地址
document.write("<script src='app.js'></script>");
var appKey = "cn.ynzs.ynzs"; //定义升级所需的API KEY

/**
 * 升级请求,notice=0为不提示
 * @param {notice} 是否提示
 */
function checkUpdate(notice) {
	var info1 = "当前应用APPID：" + plus.runtime.appid;
	info1 += ",当前应用客户端的版本号：" + plus.runtime.version;
	info1 += ",当前应用客户端5+运行环境的版本号：" + plus.runtime.innerVersion;
	console.log(info1);
	plus.runtime.getProperty(plus.runtime.appid, function(inf) {
		var info2 = "当前运行APPID：" + inf.appid;
		info2 += ",当前运行版本号：" + inf.version;
		info2 += ",当前运行APP名称：" + inf.name;
		console.log(info2);
		//android作为完整更新，ios作为增量更新，完整更新为对比框架版本，增量更新为对比运行版本
		getUpdata({
			id: 2,
			method: "CheckAppVersion",
			params: {
				"appKey": appKey,
				"type": "android"
			}
		}, function(data) {
			if(compareVer(plus.runtime.version, data.versionName)) {
				console.log(plus.runtime.version + ',' + data.versionName);
				if(!mui.os.ios) {
					mui.confirm(data.changeLog, data.updateTips, ["立即下载", "取消"], function(e) {
						if(e.index == 0) {
							console.log("正在进行完整更新！")
							downWgt(data.appHttpsUrl, notice);
						}
					});
				}
			} else {
				getUpdata({
					id: 2,
					method: "CheckAppVersion",
					params: {
						"appKey": appKey,
						"type": "ios"
					}
				}, function(data) {
					if(notice == 0) {
						if(compareVer(inf.version, data.versionName)) {
							mui.confirm(data.changeLog, data.updateTips, ["立即更新", "取消"], function(e) {
								if(e.index == 0) {
									console.log("正在进行增量更新！")
									downWgt(data.appHttpsUrl, notice);
								}
							});
						}
					} else {
						if(compareVer(inf.version, data.versionName)) {
							mui.confirm(data.changeLog, data.updateTips, ["立即更新", "取消"], function(e) {
								if(e.index == 0) {
									console.log("正在进行增量更新！")
									downWgt(data.appHttpsUrl, notice);
								}
							});
						} else {
							plus.nativeUI.alert("已经是最新版本 v" + inf.version);
						}
					}
				})
			}
		});
	});
}

/**
 * 下载升级文件
 * @param {wgetUrl} 下载链接
 * @param {notice} 是否提示

 */
function downWgt(wgetUrl, notice) {
	console.log("开始进行资源下载:" + wgetUrl);
	var w = plus.nativeUI.showWaiting("正在更新", {
		width: "100%",
		height: "106%",
		round: 1,
		textalign: "center",
		size: 14,
		modal: false,
		padding: "5%",
		background: "rgba(2,2,2,0.5)",
		color: "rgba(255,255,255,1)",
		loading: {
			display: "block",
			height: "16%",
			icon: "/images/loading.png",
			interval: 100
		}
	});
	var options = {
		method: "GET"
	};
	dtask = plus.downloader.createDownload(wgetUrl, options, {
		filename: "_doc/update/"
	});
	dtask.start();
	var i = 0,
		progress = 0;
	dtask.addEventListener("statechanged", function(task, status) {
		switch(task.state) {
			case 1: // 开始
				w.setTitle("开始下载...");
				break;
			case 2: // 已连接到服务器
				w.setTitle("正在下载...");
				break;
			case 3:
				progress = Math.round(task.downloadedSize / task.totalSize * 100);
				if(mui.os.ios) {
					w.setTitle("已下载" + parseInt(progress) + "%");
					console.log("已下载" + parseInt(progress) + "%");
				} else {
					if(progress == i) {
						i += 10;
						console.log("已下载" + parseInt(progress) + "%");
						w.setTitle("已下载" + parseInt(progress) + "%");
					}
				}
				break;
			case 4: // 下载完成
				w.setTitle("正在更新APP，请稍等!");
				installWgt(dtask.filename, notice);
				break;
		}
	});
}

//安装文件
/**
 * 安装更新文件
 * @param {path} 更新文件路径
 * @param {notice} 是否提示
 */
function installWgt(path, notice) {
	plus.runtime.install(path, {}, function() {
		console.log("安装文件成功！");
		loadClose();
		if(notice == 0) {
			mui.toast("更新成功，系统将在重新运行后更新!");
			plus.runtime.restart();
		} else {
			mui.toast("更新成功，系统将自动重启!");
			plus.runtime.restart();
		}
	}, function(e) {
		console.log("安装文件失败[" + e.code + "]：" + e.message);
	});
}

/**
 * 对比版本,并返回是否为新版本
 * @param {oVer} 本地版本
 * @param {nVer} 服务器版本
 * @returns {true/false} 
 */
function compareVer(oVer, nVer) {
	oVer = toNum(oVer);
	nVer = toNum(nVer);
	console.log("本地版本：" + oVer + ",新版本：" + nVer);
	if(oVer == nVer) {
		return false;
	}
	if(oVer > nVer) {
		return false;
	}
	if(oVer < nVer) {
		return true;
	}
}

/**
 * 版本转换数字
 * @param {a} 待转换字符
 *  @returns {res} 转换后的数字
 */
function toNum(a) {
	var a = a.toString(); //也可以这样写 
	var c = a.split(/\./);
	var c = a.split('.');
	var num_place = ["", "0", "00", "000", "0000"],
		r = num_place.reverse();
	for(var i = 0; i < c.length; i++) {
		var len = c[i].length;
		c[i] = r[len] + c[i];
	}
	var res = c.join('');
	return res;
}

/**
 * 向服务器请求升级信息
 * @param {datas} 请求参数
 * @param {func} 回调
 * @returns {func}
 */
function getUpdata(datas, func) {
	console.log("升级请求参数：" + JSON.stringify(datas));
	mui.ajax({
		url: updataUrl,
		type: 'POST',
		data: JSON.stringify(datas),
		dataType: 'json',
		timeout: 10000,
		success: function(data) {
			console.log(JSON.stringify(data));
			if(data.result.status == "success") {
				func(data.result.result);
				loadClose();
			} else {
				loadClose();
				console.log("请求数据失败！");
				plus.nativeUI.alert(data.result.result.message);
			}
		},
		error: function(xhr, type, errorThrown) {
			loadClose();
			errorHandler(xhr, type, errorThrown)
		}
	});
}